#ifndef _Figure3D_h_ 
#define _Figure3D_h_ 

#include <QGLWidget> 

class Figure3D : public QGLWidget //    Figure3D ,    QGLWidget
{ 

private: 
   GLuint m_nFigure3D;  //  m_nFigure3D     ??
   GLdouble m_xRotate;  // ,      X
   GLdouble m_yRotate;  // ,      Y
   GLdouble m_zRotate;  // ,      Z
   GLfloat m_Scale;     // ,    
   QPoint m_ptPosition; // ,       

//    QGLWidget   
protected:
   virtual void initializeGL();                    //    ,   OpenGL 
   virtual void resizeGL(int nWidth, int nHeight); //      
   virtual void paintGL();                         // ,     
   
   virtual void mousePressEvent(QMouseEvent* pe);  //         ()
   virtual void mouseMoveEvent(QMouseEvent* pe);   //         ()
   
   virtual void keyPressEvent(QKeyEvent* pe);      //       
   
           GLuint createFigure3D(GLfloat fSize = 1.0f); //        ?? 


public: 
   Figure3D(QWidget* pwgt = 0) ; // //  --   pwgt  QWidget (= 0 --  )
}; 

#endif //_Figure3D_h_ 